robert.tomczyk | 6881a59 | 2020-10-08 13:50:22 +0100 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | # ============LICENSE_START======================================================= |
| 4 | # Copyright (C) 2020 The Nordix Foundation. All rights reserved. |
| 5 | # ================================================================================ |
| 6 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 7 | # you may not use this file except in compliance with the License. |
| 8 | # You may obtain a copy of the License at |
| 9 | # |
| 10 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 11 | # |
| 12 | # Unless required by applicable law or agreed to in writing, software |
| 13 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 14 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 15 | # See the License for the specific language governing permissions and |
| 16 | # limitations under the License. |
| 17 | # |
| 18 | # SPDX-License-Identifier: Apache-2.0 |
| 19 | # ============LICENSE_END========================================================= |
| 20 | |
| 21 | # |
| 22 | # This script will take the single commit form the given Nordix Gerrit review |
| 23 | # and push it, and all its ancestor commit till $GERRIT_BRANCH, to FDio Gerrit. |
| 24 | # Pre-requisites for script to run successfully: |
| 25 | # - The Gerrit username in Nordix needs to match with the Gerrit |
| 26 | # username in FDio Gerrit |
| 27 | # - infra public key on build server needs to be added to your users SSH |
| 28 | # Public Keys in FDio Gerrit |
| 29 | # |
| 30 | set -euxo pipefail |
| 31 | |
| 32 | cd "$WORKSPACE" |
| 33 | |
| 34 | fdio_gerrit_base='gerrit.fd.io:29418' |
| 35 | nordix_gerrit_rest='https://gerrit.nordix.org' |
| 36 | |
| 37 | echo >&2 "Collecting information about what and how to push towards Fast Data Project (FDio)" |
| 38 | |
| 39 | # The git hash of the commit in the review this job runs on |
| 40 | commit_hash="$GERRIT_PATCHSET_REVISION" |
| 41 | |
| 42 | # GERRIT_PROJECT is in the form of fdio/<opendev-project> |
| 43 | fdio_project=$(echo "$GERRIT_PROJECT" | cut -d/ -f2- ) |
| 44 | |
| 45 | # Nordix Gerrit can map the email address of the user pushed the change to |
| 46 | # the review to the Gerrit username of the account in Nordix Gerrit. This |
| 47 | # should match with the Gerrit username in the FDio Gerrit. |
| 48 | username=$( |
| 49 | curl -s -H 'Accept: application/json' \ |
| 50 | "$nordix_gerrit_rest/accounts/?q=email:$GERRIT_EVENT_ACCOUNT_EMAIL&o=DETAILS" \ |
| 51 | | tee /dev/stderr | tail -1 | jq -r '.[0].username') |
| 52 | |
| 53 | fdio_remote_url="ssh://$username@$fdio_gerrit_base/$fdio_project" |
| 54 | |
| 55 | # GERRIT_BRANCH is the _intended_ branch of the commit under review |
| 56 | # E.g. git push HEAD:refs/for/master => GERRIT_BRANCH='master' |
| 57 | # GERRIT_TOPIC is the rest of the refspec after GERRIT_BRANCH when the topic |
| 58 | # is set for the change. |
| 59 | if [ -z "${GERRIT_TOPIC:-}" ] ; then |
robert.tomczyk | 40f6015 | 2020-10-13 11:03:13 +0100 | [diff] [blame] | 60 | refspec="${commit_hash}:refs/for/${GERRIT_BRANCH}" |
robert.tomczyk | 6881a59 | 2020-10-08 13:50:22 +0100 | [diff] [blame] | 61 | else |
robert.tomczyk | 40f6015 | 2020-10-13 11:03:13 +0100 | [diff] [blame] | 62 | refspec="${commit_hash}:refs/for/${GERRIT_BRANCH}%topic=${GERRIT_TOPIC}" |
robert.tomczyk | 6881a59 | 2020-10-08 13:50:22 +0100 | [diff] [blame] | 63 | fi |
| 64 | |
| 65 | echo >&2 "Pushing to FDio Gerrit" |
| 66 | |
| 67 | # do not fail if git push fails as in case of no new changes we want to succeed. See below. |
| 68 | set +o pipefail |
| 69 | |
| 70 | git push "$fdio_remote_url" "$refspec" 2>&1 | tee push_result.txt |
| 71 | push_result=${PIPESTATUS[0]} |
| 72 | |
| 73 | # make the job a success if the above git push fails due to no new changes are needed |
| 74 | # to be created upstream. This will be useful when we switch to automatic triggering |
| 75 | # of the push-upstream for each patch set and jobs on different commits in a same chain |
| 76 | # will race with each other to push parts of the chain |
| 77 | if [ $push_result -ne 0 ]; then |
| 78 | grep '(no new changes)' push_result.txt |
| 79 | fi |